/*
* $Log: main.c,v $
* Revision 1.8  2004/01/31 18:36:33  Default
* object palette now set dynamically
*
* Revision 1.7  2004/01/30 22:52:34  Default
* Main loop altered a bit to take gameover into account!
*
* Revision 1.6  2004/01/27 20:19:13  richq
* The temp lord object has changed - it's now a pointer to the actual
* table entry and gets rid of the need for all the copying
* from temp to the table and back again.
*
* Revision 1.5  2004/01/27 19:37:39  richq
* title screen called
*
* Revision 1.4  2004/01/25 21:25:36  richq
* palette for object gfx
*
* Revision 1.3  2004/01/22 20:02:59  richq
* Map intialisation added.
*
* Revision 1.2  2004/01/21 19:11:45  Default
* Added init calls for various modules.     
* Moved graphics specific stuff to gfx.c    
*                                           
* Revision 1.1.1.1  2004/01/17 09:32:34  Default
* Lords Of Midnight GBA
*
*
*/

#include "gba.h"
#include "screenmode.h"
#include "interupts.h"
#include "sprite.h"

#include "gfx.h"
#include "input.h"
#include "inter.h"
#include "location.h"
#include "lords.h"
#include "places.h"
#include "army.h"
#include "savearea.h"
#include "tokens.h"
#include "shield.h"
#include "look.h"

void Setup(void);
void init_interrupts(void);
void wait_vsync_int(void);
void showSplash(void);

int AgbMain(void)
{
  clear_vram();
  init_interrupts();
  while (1) {
    showSplash();
    clear_vram();
    Setup();
      
    set_horizon();
    look();
    
    
    fade_up();
    g_gameover = 0;
    while(g_gameover == 0) {  
      handle_keys();
      wait_vsync_int();
    }
    fade_down();
    clear_vram();
  }
  
}

// uses simple interupts...
void init_interrupts(void) {
  
  REG_IME = 0x00;
  REG_IE = INT_VBLANK;//|INT_HBLANK;
  REG_IF = INT_VBLANK;
  REG_DISPSTAT = BIT03;//|0x10; // Enable Display V-Blank | HBLANK IRQ also.
  REG_INTERUPT = (u32)VBlankInterruptHandler;  // Set interrupt proc address (IRQHandler) 
  REG_IME = 0x01;
  
  game_frames = 0;
}


void Setup(void) {
  
  SetMode(MODE_0 | BG0_ENABLE | OBJ_ENABLE | OBJ_MAP_1D);
  
  // set all the sprites to "not for processing" state
  u16 loop;
  for(loop = 0; loop < 128; loop++)  {
    remove_sprite(loop);
  }
  CopyOAM();
  
  // initialise the various buffers, data sets, etc
  init_map();
  init_gfxbuffer();
  init_army();
  init_savearea();
  init_token_buffers();
  init_lordtable();
  init_backgrounds();
  
  load_font();
  init_shield_pal();
    
}
